# Y7SETUP version 0.2a

**YMF724/744/754 setup utility**

DOS から YAMAHA 製音源チップである YMF724/744/754 の設定を行うツールです。

PC-98 の PCI スロット搭載機種で YMF7x4 の OPL3 機能を使うことを第一として作成したため、現時点では設定できない項目や特定の値に設定されてしまう項目があります(本 README の「定数を設定している項目」を参照してください)。

version 0.2a で PC-98 依存のコードを取り除き、PC/AT 互換機も動作対象に含まれるようにしました。

このプログラムは3条項 BSD ライセンスの下にリリースされています。


## 動作環境

このプログラムは DOS 上で動作するプログラムです。
また、すべての機能を利用するためには以下の要件を満たす必要があります。

- PCI BIOS (int 1ah)が使えること
    - 本プログラムでは PCI デバイスへのアクセスに PCI BIOS を利用しています
    - そのため PCI BIOS がないと PCI デバイスへのアクセスができません
- VCPI が使えること
    - PCI の MMIO にアクセスするために VCPI を利用します
    - VCPI がない環境では一部の項目を設定できません


## 使用上の注意点

YMF724/744/754 にアクセスする他のプログラムの実行中にこのプログラムを実行した場合、その結果は保証されません。
そのような状況の動作確認は一切行っていませんので、YMF724/744/754 にこのプログラム以外のプログラムが同時にアクセスするようがないようご注意ください。


## プログラムの使い方

### ヘルプ表示

書式：`y7setup.exe help`

受け付けるプログラム引数の説明が表示されます。

### YMF724/744/754 の列挙

書式：`y7setup.exe list`

現在認識可能な YMF724/744/754 の PCI バス上での位置(バス番号、デバイス番号、ファンクション番号)を列挙します。バス上での位置の表示形式は `lspci` コマンドと同様です。

YMF744 がバス番号=00h, デバイス番号=0dh, ファンクション番号=0hの位置に1個ある場合の表示例

```
YMF724:
YMF744: 00:0D.0
YMF754:
```

### YMF724/744/754 の状態表示

書式：`y7setup.exe get [デバイス位置]`

指定の位置にある YMF724/744/754 の設定項目のうち、Y7SETUP.EXE で設定可能な項目に関係するものの値を表示します。

デバイス位置の書式は list コマンドで表示されるものと同じです。

### YMF724/744/754 の設定

書式：`y7setup.exe set [デバイス位置] [設定項目] [設定値]`

指定の位置にある YMF724/744/754 の指定された項目の設定を行います。

設定可能な項目は以下の4個です。

- `opl3`：OPL3 のベースアドレス及び同ブロックの IO 空間へのマッピングの有無
    - 0～ffff: ベースアドレスを指定の値にして同ブロックを有効化します
    - off: 同ブロックを無効化します
- `sbpro`：Sound Blaster ブロックのベースアドレス及び同ブロックの IO 空間へのマッピングの有無
    - 0～ffff: ベースアドレスを指定の値にして同ブロックを有効化します
    - off: 同ブロックを無効化します
- `lvol`：レガシオーディオブロックの音量
    - 0～3fff: 音量を指定された値に設定します(3fff が最大、0が最小音量です)
- `avol`: YMF724/744/754 に接続されている AC'97 のマスタ音量
    - 0～3f: 音量を指定された値に設定します(0 が最大、3f が最小音量です)
- `ivol`: YMF724/744/754 に接続されている AC'97 のライン入力音量
    - 0～3f: 音量を指定された値に設定します(0 が最大、3f が最小音量です)
    - mute: ライン入力をミュートします

設定できる音量の項目は上記2項目しかないため、そのようなボードがあるか知りませんが、YMF724/744/754 と AC'97 の組み合わせでないボードについては音量設定ができない可能性があります。

プログラム引数として受け付ける AC'97 のマスタ音量及びライン入力音量の範囲は 0～3fh となっていますが、5ビット目はオプションなので、環境によっては最大 1fh までの値しか設定できない可能性があります。


## 定数を設定している項目

冒頭での記述のとおり、YMF7x4 の OPL3 機能を使うことを第一として作成したため、現状一部の設定項目は一律に特定の値に設定される仕様となっています。

OPL3 を利用できるようにするだけであれば機能的に不足はないのですが、プログラムの汎用性を考えるとこのような仕様はあまり望ましくないので、今後設定可能な項目を増やすかもしれません。

- LAD (Legacy Audio Disable)
    - OPL3/SBPro のベースアドレス指定時に0となります
    - 別のブロックが有効な可能性があるため `off` 指定時も1にはしません
- SIEN (Serialized IRQ Enable)
    - OPL3/SBPro のベースアドレス指定時に1となります
    - レガシオーディオの割り込み信号が Serialized IRQ に出力されるようになります
    - OPL3 の割り込み信号は外に出せないので、OPL3 には関係ありません
- I/O (I/O Address Aliasing Control)
    - OPL3/SBPro のベースアドレス指定時に0(16ビットアドレスデコード)となります
- MPU401 とジョイスティック関係の機能は無効化しています
    - OPL3/SBPro のベースアドレス指定時に以下の設定となります
    - GPEN (Gameport Enable)は0になります
    - MEN (MPU401 Enable)は0になります
    - MAIM (MPU401 Acknowledge Interrup Mask)は1になります
- CRST (AC'97 Software Reset Signal Control)
    - AC'97 の音量設定時に0(リセット信号無効)になります
- AC'97 の PCM Out Vol (Analog Mixer Input Gain Reigsters, 18h)
    - AC'97 の音量設定時に8080h(0dB gain)になります


## 依存ライブラリ

PCI の MMIO へのアクセスには拙作 VPMXFER を使っています。


## 作者・更新履歴
あめさろだ(rainy-srd, r-srd), mail: r-srd@outlook.jp

* 2023-11-03, version 0.2a
    * AC'97 の line in volume を設定する機能を追加
    * PC-98 依存のコードを非依存のコードに変更
* 2022-12-04, version 0.1b
    * YMF724/744/754 への同時アクセスに関する注意書きを README に追加
* 2022-06-19, version 0.1a
    * AC'97 へのリセット信号が有効な状態で AC'97 にアクセスするとハングすることがあったためハングしないように対処
* 2022-06-11, version 0.1
    * 初版
